diff --git a/src/pl/plpython/plpy_typeio.c b/src/pl/plpython/plpy_typeio.c
index d5cac9f..914e033 100644
*** a/src/pl/plpython/plpy_typeio.c
--- b/src/pl/plpython/plpy_typeio.c
*************** PLy_typeinfo_dealloc(PLyTypeInfo *arg)
*** 73,78 ****
--- 73,88 ----
  {
  	if (arg->is_rowtype == 1)
  	{
+ 		if (arg->in.r.natts > 0)
+ 		{
+ 			int	i;
+ 
+ 			for (i = 0; i < arg->in.r.natts; i++)
+ 			{
+ 				if (arg->in.r.atts[i].elm != NULL)
+ 					PLy_free(arg->in.r.atts[i].elm);
+ 			}
+ 		}
  		if (arg->in.r.atts)
  			PLy_free(arg->in.r.atts);
  		if (arg->out.r.atts)
